VTK: vtkCellLinks Class Reference

| VTK 9.3.1

Classes | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkCellLinks Class Reference

object represents upward pointers from points to list of cells using each point More...

`#include <vtkCellLinks.h>`

Inheritance diagram for vtkCellLinks:
[legend]
Collaboration diagram for vtkCellLinks:
[legend]

## Classes
class | Link

## Public Member Functions
void | BuildLinks () override
| Build the link list array from the input dataset. More...
void | Allocate (vtkIdType numLinks, vtkIdType ext=1000)
| Allocate the specified number of links (i.e., number of points) that will be built. More...
void | Initialize () override
| Clear out any previously allocated data structures. More...
Link & | GetLink (vtkIdType ptId)
| Get a link structure given a point id. More...
vtkIdType | GetNcells (vtkIdType ptId)
| Get the number of cells using the point specified by ptId. More...
vtkIdType * | GetCells (vtkIdType ptId)
| Return a list of cell ids using the point. More...
vtkIdType | InsertNextPoint (int numLinks)
| Insert a new point into the cell-links data structure. More...
void | InsertNextCellReference (vtkIdType ptId, vtkIdType cellId)
| Insert a cell id into the list of cells (at the end) using the cell id provided. More...
void | DeletePoint (vtkIdType ptId)
| Delete point (and storage) by destroying links to using cells. More...
void | RemoveCellReference (vtkIdType cellId, vtkIdType ptId)
| Delete the reference to the cell (cellId) from the point (ptId). More...
void | AddCellReference (vtkIdType cellId, vtkIdType ptId)
| Add the reference to the cell (cellId) from the point (ptId). More...
void | ResizeCellList (vtkIdType ptId, int size)
| Change the length of a point's link list (i.e., list of cells using a point) by the size specified. More...
void | Squeeze () override
| Reclaim any unused memory. More...
void | Reset () override
| Reset to a state of no entries without freeing the memory. More...
unsigned long | GetActualMemorySize () override
| Return the memory in kibibytes (1024 bytes) consumed by this cell links array. More...
void | DeepCopy (vtkAbstractCellLinks *src) override
| Standard DeepCopy method. More...
void | SelectCells (vtkIdType minMaxDegree[2], unsigned char *cellSelection) override
| Select all cells with a point degree in the range [minDegree,maxDegree). More...
Public Member Functions inherited from vtkAbstractCellLinks
void | BuildLinks (vtkDataSet *data)
| Set the input dataset and build the link list array. More...
virtual int | GetType ()
| Return the type of locator (see enum above). More...
virtual void | SetDataSet (vtkDataSet *)
| Set/Get the points/cells defining this dataset. More...
virtual vtkDataSet * | GetDataSet ()
| Set/Get the points/cells defining this dataset. More...
virtual void | SetSequentialProcessing (bool)
| Force sequential processing (i.e. More...
virtual bool | GetSequentialProcessing ()
| Force sequential processing (i.e. More...
virtual void | SequentialProcessingOn ()
| Force sequential processing (i.e. More...
virtual void | SequentialProcessingOff ()
| Force sequential processing (i.e. More...
virtual vtkMTimeType | GetBuildTime ()
| Return the time of the last data structure build. More...
bool | UsesGarbageCollector () const override
| Handle the dataset <-> Links loop. More...
vtkAbstractCellLinks * | NewInstance () const
| Standard type and print methods. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Protected Member Functions
| vtkCellLinks ()
| ~vtkCellLinks () override
void | IncrementLinkCount (vtkIdType ptId)
| Increment the count of the number of cells using the point. More...
void | AllocateLinks (vtkIdType n)
void | InsertCellReference (vtkIdType ptId, vtkIdType pos, vtkIdType cellId)
| Insert a cell id into the list of cells using the point. More...
Link * | Resize (vtkIdType sz)
Protected Member Functions inherited from vtkAbstractCellLinks
| vtkAbstractCellLinks ()
| ~vtkAbstractCellLinks () override
void | ReportReferences (vtkGarbageCollector *) override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
Link * | Array
vtkIdType | Size
vtkIdType | MaxId
vtkIdType | Extend
vtkIdType | NumberOfPoints
vtkIdType | NumberOfCells
Protected Attributes inherited from vtkAbstractCellLinks
vtkDataSet * | DataSet
bool | SequentialProcessing
int | Type
vtkTimeStamp | BuildTime
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkAbstractCellLinks | Superclass
| Standard methods to instantiate, print, and obtain type information. More...
static vtkCellLinks * | New ()
| Standard methods to instantiate, print, and obtain type information. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods to instantiate, print, and obtain type information. More...
static vtkCellLinks * | SafeDownCast (vtkObjectBase *o)
| Standard methods to instantiate, print, and obtain type information. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods to instantiate, print, and obtain type information. More...
vtkCellLinks * | NewInstance () const
| Standard methods to instantiate, print, and obtain type information. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods to instantiate, print, and obtain type information. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods to instantiate, print, and obtain type information. More...

## Additional Inherited Members
Public Types inherited from vtkAbstractCellLinks
enum | CellLinksTypes { LINKS_NOT_DEFINED = 0 , CELL_LINKS = 1 , STATIC_CELL_LINKS_USHORT = 2 , STATIC_CELL_LINKS_UINT = 3 , STATIC_CELL_LINKS_IDTYPE = 4 , STATIC_CELL_LINKS_SPECIALIZED = 5 }
typedef vtkObject | Superclass
| Standard type and print methods. More...
Static Public Member Functions inherited from vtkAbstractCellLinks
static int | ComputeType (vtkIdType maxPtId, vtkIdType maxCellId, vtkCellArray *ca)
| Based on the input (i.e., number of points, number of cells, and length of connectivity array) this helper method returns the integral type to use when instantiating cell link-related classes in order to properly represent the data. More...
static int | ComputeType (vtkIdType maxPtId, vtkIdType maxCellId, vtkIdType connectivitySize)
static vtkTypeBool | IsTypeOf (const char *type)
| Standard type and print methods. More...
static vtkAbstractCellLinks * | SafeDownCast (vtkObjectBase *o)
| Standard type and print methods. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

object represents upward pointers from points to list of cells using each point

vtkCellLinks is a supplemental object to vtkCellArray and vtkCellTypes, enabling access from points to the cells using the points. vtkCellLinks is a list of cell ids, each such link representing a dynamic list of cell ids using the point. The information provided by this object can be used to determine neighbors and construct other local topological information.

Warning
  vtkCellLinks supports incremental (i.e., "editable") operations such as inserting a new cell, or deleting a point. Because of this, it is less memory efficient, and slower to construct and delete than static classes such as vtkStaticCellLinks or vtkStaticCellLinksTemplate. However these other classes are typically meant for one-time (static) construction.

See also
  vtkCellArray vtkCellTypes vtkStaticCellLinks vtkStaticCellLinksTemplate

Definition at line 34 of file vtkCellLinks.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkAbstractCellLinks vtkCellLinks::Superclass

Standard methods to instantiate, print, and obtain type information.

Definition at line 49 of file vtkCellLinks.h.

## Constructor & Destructor Documentation

## ◆ vtkCellLinks()

vtkCellLinks::vtkCellLinks | ( |  | ) |
| protected

## ◆ ~vtkCellLinks()

vtkCellLinks::~vtkCellLinks | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkCellLinks* vtkCellLinks::New | ( |  | ) |
| static

Standard methods to instantiate, print, and obtain type information.

## ◆ IsTypeOf()

static vtkTypeBool vtkCellLinks::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods to instantiate, print, and obtain type information.

## ◆ IsA()

virtual vtkTypeBool vtkCellLinks::IsA | ( | const char * | type | ) |
| virtual

Standard methods to instantiate, print, and obtain type information.

Reimplemented from vtkAbstractCellLinks.

## ◆ SafeDownCast()

static vtkCellLinks* vtkCellLinks::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods to instantiate, print, and obtain type information.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkCellLinks::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods to instantiate, print, and obtain type information.

Reimplemented from vtkAbstractCellLinks.

## ◆ NewInstance()

vtkCellLinks* vtkCellLinks::NewInstance | ( |  | ) | const

Standard methods to instantiate, print, and obtain type information.

## ◆ PrintSelf()

void vtkCellLinks::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods to instantiate, print, and obtain type information.

Reimplemented from vtkAbstractCellLinks.

## ◆ BuildLinks()

void vtkCellLinks::BuildLinks | ( |  | ) |
| overridevirtual

Build the link list array from the input dataset.

Implements vtkAbstractCellLinks.

## ◆ Allocate()

void vtkCellLinks::Allocate | ( | vtkIdType | numLinks,
|  | vtkIdType | ext = `1000`
| ) |  |

Allocate the specified number of links (i.e., number of points) that will be built.

## ◆ Initialize()

void vtkCellLinks::Initialize | ( |  | ) |
| overridevirtual

Clear out any previously allocated data structures.

Implements vtkAbstractCellLinks.

## ◆ GetLink()

Link& vtkCellLinks::GetLink | ( | vtkIdType | ptId | ) |
| inline

Get a link structure given a point id.

Definition at line 72 of file vtkCellLinks.h.

## ◆ GetNcells()

vtkIdType vtkCellLinks::GetNcells | ( | vtkIdType | ptId | ) |
| inline

Get the number of cells using the point specified by ptId.

Definition at line 77 of file vtkCellLinks.h.

## ◆ GetCells()

vtkIdType* vtkCellLinks::GetCells | ( | vtkIdType | ptId | ) |
| inline

Return a list of cell ids using the point.

Definition at line 82 of file vtkCellLinks.h.

## ◆ SelectCells()

void vtkCellLinks::SelectCells | ( | vtkIdType | minMaxDegree[2],
|  | unsigned char * | cellSelection
| ) |  |
| overridevirtual

Select all cells with a point degree in the range [minDegree,maxDegree).

The degree is the number of cells using a point. The selection is indicated through the provided unsigned char array, with a non-zero value indicates selection. The memory allocated for cellSelection must be the maximum cell id referenced in the links.

Implements vtkAbstractCellLinks.

## ◆ InsertNextPoint()

vtkIdType vtkCellLinks::InsertNextPoint | ( | int | numLinks | ) |

Insert a new point into the cell-links data structure.

The size parameter is the initial size of the list.

## ◆ InsertNextCellReference()

void vtkCellLinks::InsertNextCellReference | ( | vtkIdType | ptId,
|  | vtkIdType | cellId
| ) |  |
| inline

Insert a cell id into the list of cells (at the end) using the cell id provided.

(Make sure to extend the link list (if necessary) using the method ResizeCellList().)

Definition at line 205 of file vtkCellLinks.h.

## ◆ DeletePoint()

void vtkCellLinks::DeletePoint | ( | vtkIdType | ptId | ) |
| inline

Delete point (and storage) by destroying links to using cells.

Definition at line 197 of file vtkCellLinks.h.

## ◆ RemoveCellReference()

void vtkCellLinks::RemoveCellReference | ( | vtkIdType | cellId,
|  | vtkIdType | ptId
| ) |  |
| inline

Delete the reference to the cell (cellId) from the point (ptId).

This removes the reference to the cellId from the cell list, but does not resize the list (recover memory with ResizeCellList(), if necessary).

Definition at line 211 of file vtkCellLinks.h.

## ◆ AddCellReference()

void vtkCellLinks::AddCellReference | ( | vtkIdType | cellId,
|  | vtkIdType | ptId
| ) |  |
| inline

Add the reference to the cell (cellId) from the point (ptId).

This adds a reference to the cellId from the cell list, but does not resize the list (extend memory with ResizeCellList(), if necessary).

Definition at line 231 of file vtkCellLinks.h.

## ◆ ResizeCellList()

void vtkCellLinks::ResizeCellList | ( | vtkIdType | ptId,
|  | int | size
| ) |  |
| inline

Change the length of a point's link list (i.e., list of cells using a point) by the size specified.

Definition at line 237 of file vtkCellLinks.h.

## ◆ Squeeze()

void vtkCellLinks::Squeeze | ( |  | ) |
| overridevirtual

Reclaim any unused memory.

Implements vtkAbstractCellLinks.

## ◆ Reset()

void vtkCellLinks::Reset | ( |  | ) |
| overridevirtual

Reset to a state of no entries without freeing the memory.

Implements vtkAbstractCellLinks.

## ◆ GetActualMemorySize()

unsigned long vtkCellLinks::GetActualMemorySize | ( |  | ) |
| overridevirtual

Return the memory in kibibytes (1024 bytes) consumed by this cell links array.

Used to support streaming and reading/writing data. The value returned is guaranteed to be greater than or equal to the memory required to actually represent the data represented by this object. The information returned is valid only after the pipeline has been updated.

Implements vtkAbstractCellLinks.

## ◆ DeepCopy()

void vtkCellLinks::DeepCopy | ( | vtkAbstractCellLinks * | src | ) |
| overridevirtual

Standard DeepCopy method.

Since this object contains no reference to other objects, there is no ShallowCopy.

Implements vtkAbstractCellLinks.

## ◆ IncrementLinkCount()

void vtkCellLinks::IncrementLinkCount | ( | vtkIdType | ptId | ) |
| inlineprotected

Increment the count of the number of cells using the point.

Definition at line 166 of file vtkCellLinks.h.

## ◆ AllocateLinks()

void vtkCellLinks::AllocateLinks | ( | vtkIdType | n | ) |
| protected

## ◆ InsertCellReference()

void vtkCellLinks::InsertCellReference | ( | vtkIdType | ptId,
|  | vtkIdType | pos,
|  | vtkIdType | cellId
| ) |  |
| inlineprotected

Insert a cell id into the list of cells using the point.

Definition at line 191 of file vtkCellLinks.h.

## ◆ Resize()

Link* vtkCellLinks::Resize | ( | vtkIdType | sz | ) |
| protected

## Member Data Documentation

## ◆ Array

Link* vtkCellLinks::Array
| protected

Definition at line 175 of file vtkCellLinks.h.

## ◆ Size

vtkIdType vtkCellLinks::Size
| protected

Definition at line 176 of file vtkCellLinks.h.

## ◆ MaxId

vtkIdType vtkCellLinks::MaxId
| protected

Definition at line 177 of file vtkCellLinks.h.

## ◆ Extend

vtkIdType vtkCellLinks::Extend
| protected

Definition at line 178 of file vtkCellLinks.h.

## ◆ NumberOfPoints

vtkIdType vtkCellLinks::NumberOfPoints
| protected

Definition at line 182 of file vtkCellLinks.h.

## ◆ NumberOfCells

vtkIdType vtkCellLinks::NumberOfCells
| protected

Definition at line 183 of file vtkCellLinks.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkCellLinks.h